#include <amxmodx>
#include <cstrike>
#include <fun>

new msgScoreInfo, msgSayText

public plugin_init()
{
	register_plugin("Daj Fraga", "1.0", "Pavulon")
	
	register_clcmd("say", "cmd_frag")
	register_clcmd("say_team", "cmd_frag")
	
	msgScoreInfo = get_user_msgid("ScoreInfo")
	msgSayText = get_user_msgid("SayText")
}

public cmd_frag(id)
{
	new msg[128]
	read_args(msg, 127) 
	remove_quotes(msg)
	
	new arg1[10], arg2[36], arg3[5]
	parse(msg, arg1, 9, arg2, 35, arg3, 4) 

	if (!equal(arg1, "frag") && !equal(arg1, "daj_fraga"))
		return PLUGIN_CONTINUE

	new CsTeams:OwnTeam = cs_get_user_team(id)
	
	if (OwnTeam!= CS_TEAM_CT && OwnTeam!=CS_TEAM_T)
	{
		col_chat(id, id, "!g[AMXX] Nie jestes juz w grze, nie mozesz przekazac fragow")
		return PLUGIN_HANDLED
	}

	if (strlen(arg2)==0)
	{
		col_chat(id, id, "!g[AMXX] Musisz podac komu chcesz dac fragi")
		return PLUGIN_HANDLED
	}
	
	new fragi = str_to_num(arg3)
	new target = znajdz_gracza(arg2)
	
	if (target <= 0)
	{
		col_chat(id, id, "!g[AMXX] Nie znaleziono gracza")
		return PLUGIN_HANDLED
	}
	
	if (target == id)
	{
		col_chat(id, id, "!g[AMXX] Nie mozesz dac fragow samemu sobie")
		return PLUGIN_HANDLED
	}
	
	new CsTeams:TargetTeam = cs_get_user_team(target)
	
	if (TargetTeam != CS_TEAM_CT && TargetTeam != CS_TEAM_T)
	{
		col_chat(id, id, "!g[AMXX] Gracz nie jest w grze, nie mozesz mu przekazac fragow")
		return PLUGIN_HANDLED
	}
	
	if (fragi <= 0)
	{
		col_chat(id, id, "!g[AMXX] Musisz podac dodatnia liczbe fragow jaka chcesz przekazac")
		return PLUGIN_HANDLED
	}
	
	new MojeFragi = get_user_frags(id)
	
	if (MojeFragi < fragi)
	{
		col_chat(id, id, "!g[AMXX] Nie masz wystarczajacej liczby fragow")
		return PLUGIN_HANDLED
	}

	
	set_user_frags(id, MojeFragi-fragi)
	
	set_user_frags(target, get_user_frags(target)+fragi)
	
	message_begin(MSG_BROADCAST, msgScoreInfo)
	write_byte(id)
	write_short(get_user_frags(id))
	write_short(get_user_deaths(id))
	write_short(0)
	write_short(get_user_team(id))
	message_end()
	
	message_begin(MSG_BROADCAST, msgScoreInfo)
	write_byte(target)
	write_short(get_user_frags(target))
	write_short(get_user_deaths(target))
	write_short(0)
	write_short(get_user_team(target))
	message_end()
	
	new OwnName[33], TargetName[33]
	get_user_name(id, OwnName, 32)
	get_user_name(target, TargetName, 32)
	
	col_chat(0, id, "!g[AMXX] !nGracz ^"!t%s!n^" przekazal !g%d !nfrag%s graczowi ^"!t%s!n^"", OwnName, fragi, ((fragi==1)?"":((fragi<5)?"i":"ow")), TargetName)
	
	return PLUGIN_HANDLED
}


stock znajdz_gracza(str[])
{
	if (strlen(str)==0)
		return -1
	
	new player = find_player("c", str) //authid

	if (!player) {
		player = find_player("bl", str) //name, ignore case
	}

	if (!player) {
		player = find_player("d", str) //ip
	}

	if ( !player && str[0]=='#' && str[1] ) {
		player = find_player("k", str_to_num(str[1])) //userid
	}
	
	if (player)
		return player
	
	return -1
}

stock col_chat(id, sender, string[], any:...)
{
	if (!id || is_user_connected(id))
	{
		static szMessage[128]
		szMessage[0] = 0x01
		vformat(szMessage[1], 127, string, 4)
	
		replace_all(szMessage, 127, "!n", "^x01")
		replace_all(szMessage, 127, "!t", "^x03")
		replace_all(szMessage, 127, "!g", "^x04")
	
		message_begin(id?MSG_ONE_UNRELIABLE:MSG_BROADCAST, msgSayText, _, id)
		write_byte(sender)
		write_string(szMessage)
		message_end()
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
